(*--------------------------------------------------------------------------*)
(*    Copyright (c) 1997 Kuleshov Sergey                                    *)
(*    Copyright (c) 1997 ExOS technologies                                  *)
(*--------------------------------------------------------------------------*)

unit keyboard;
interface
procedure clrkeybuf;
function _keypressed:boolean;
function scrll:boolean;
procedure scrllon;
procedure scrlloff;
function scankey:byte;
function asciikey:char;
implementation

procedure clrkeybuf;assembler;
asm
@ST:  MOV AH,01
      INT 16H
      JZ @END
      MOV AH,00
      INT 16H
      JMP @ST
@END:
end;

function _keypressed:boolean;
var t:byte;
begin
asm
   MOV T,1
   MOV AH,01
   INT 16H
   JZ @Y
   MOV T,0
@Y:
end;
if t=0 then _keypressed:=true else _keypressed:=false;
end;

function scrll:boolean;
var t:byte;
begin
asm
   PUSH ES
   PUSH AX
   MOV T,1
   MOV AX,$40
   MOV ES,AX
   MOV AL,[ES:$17]
   TEST AL,00010000B
   JZ @N
   MOV T,0
@N:POP AX
   POP ES
end;
if t=1 then scrll:=false else scrll:=true;
end;

procedure scrllon;assembler;
asm
   PUSH ES
   PUSH AX
   MOV AX,$40
   MOV ES,AX
   MOV AL,[ES:$17]
   OR  AL,00010000B
   MOV [ES:$17],AL
   POP AX
   POP ES
end;

procedure scrlloff;assembler;
asm
   PUSH ES
   PUSH AX
   MOV AX,$40
   MOV ES,AX
   MOV AL,[ES:$17]
   AND AL,11101111B
   MOV [ES:$17],AL
   POP AX
   POP ES
end;

function scankey:byte;
var b:byte;
begin
asm
     MOV AH,00
     INT 16H
     MOV b,AH
end;
scankey:=b;
end;

function asciikey:char;
var b:byte;
begin
asm
     MOV AH,00
     INT 16H
     MOV b,AL
end;
asciikey:=char(b);
end;

end.