(*--------------------------------------------------------------------------*)
(*    Copyright (c) 1997 Kuleshov Sergey                                    *)   
(*    Copyright (c) 1997 ExOS technologies                                  *)
(*--------------------------------------------------------------------------*)

uses graph,mouse,help,options,keyboard,calculat;
var gd,gm:integer;
    xout,yout,xgrmax,ygrmax,xgrmax2,ygrmax2,xvec,yvec:longint;
    xok,yok,zan,xx,yy,xz,xy,yx,yz,xmin,xmax,ymin,ymax,zmin,zmax,x,y,z,sc:real;
    page,xm,ym,bm:word;
    key:byte;
    menu,mouseexist:boolean;
    p:pointer;
    oo:option;
    {}
    per:perem;
    dlin:word;
    zn:string;
    dgt:fnc;

label start,stop;

(*--------------------------------------------------------------------------*)
(*                                SYSTEM                                    *)
(*--------------------------------------------------------------------------*)

function xgr(x,y,z:real):integer;
begin
z:=z*sc;
x:=x*sc;
y:=y*sc;
xgr:=round((x-xmin)*xx+(y-ymin)*xy+z*xz)+xvec;
end;

function ygr(x,y,z:real):integer;
begin
z:=z*sc;
x:=x*sc;
y:=y*sc;
{if abs(y)<ygrmax/yy+ymin then}
ygr:=ygrmax-round((y-ymin)*yy+(x-xmin)*yx+z*yz)+yvec
{else ygr:=ygrmax+1;}
end;

function noact(act:word):word;
begin
if act=0 then noact:=1 else noact:=0;
end;

{procedure bgidriver;external;}
{L egavga.obj}

(*--------------------------------------------------------------------------*)
(*                                INITIAL                                   *)
(*--------------------------------------------------------------------------*)

procedure endinit;
begin
x:=xmin;
while x<xmax do
     begin
        putpixel(xgr(x,0,0),ygr(x,0,0),green);
     x:=x+0.01;
     end;
if oo.cord then outtextxy(xgr(x,0,0)-8,ygr(x,0,0)-8,per[1]);{}
x:=ymin;
while x<ymax do
     begin
        putpixel(xgr(0,x,0),ygr(0,x,0),green);
     x:=x+0.01;
     end;
if oo.cord then outtextxy(xgr(0,x,0)-8,ygr(0,x,0)-8,'Y');
x:=zmin;
while x<zmax do
     begin
        putpixel(xgr(0,0,x),ygr(0,0,x),green);
     x:=x+0.01;
     end;
if oo.cord then outtextxy(xgr(0,0,x)-8,ygr(0,0,x)+8,per[2]);{}
menu:=false;
end;

procedure init;
begin
oo.cord:=true;{}
oo.an:=pi/12;
oo.sm:=1;
setvisualpage(0);
cleardevice;
mouseon;
oo.dm:=0.8;oo.dn:=0.05;
xmin:=-10;xmax:=10;
ymin:=-10;ymax:=10;
zmin:=-10;zmax:=10;
xgrmax:=getmaxx;
xgrmax2:=xgrmax div 2;
ygrmax:=getmaxy;
ygrmax2:=ygrmax div 2;
xx:=xgrmax/(xmax-xmin);
yy:=ygrmax/(ymax-ymin);
xz:=xx;yz:=yy;
xy:=0;yx:=0;
xvec:=0;yvec:=0;
page:=0;
sc:=1;
zan:=0;
xok:=xx;yok:=yy;
{endinit;}
end;

(*--------------------------------------------------------------------------*)
(*                                FUNCTION                                  *)
(*--------------------------------------------------------------------------*
function f(zn,z:real):real;
begin
if (x<>0)and(z<>0) then
   f:=15/(x*x+z*z+1){sin(x)+cos(z)}
   else f:=ygrmax+1;
end;
*--------------------------------------------------------------------------*)
(*                                ROTATION                                  *)
(*--------------------------------------------------------------------------*)

{xy- OY  Z}
{yx-   Z}
{xx-⠡ }
{yy-⠡ Y}
{xz- OZ  OY}
{yz- OZ  OX}

procedure rotz(an:real);
begin
zan:=zan+an;
{  xx:=xx*cos (an)-xy*sin(an);}
   xy:=xx*sin(an)+xy*cos(an);
   yx:=yx*cos(an)-yy*sin(an);
{  yy:=yx*sin(an)+yy*cos(an);}
   xx:=xok*cos(zan);yy:=yok*cos(zan);
   xvec:=xgrmax2-round((-xmin)*xx+(-ymin)*xy);
   yvec:=ygrmax2-ygrmax+round((-ymin)*yy+(-xmin)*yx);
end;

procedure movez(an:real);
begin
   zmin:=zmin+an;
   zmax:=zmax+an;
   xvec:=xgrmax2-round((-xmin)*xx+(-ymin)*xy);
   yvec:=ygrmax2-ygrmax+round((-ymin)*yy+(-xmin)*yx);
end;

procedure rotx(an:real);
begin
if scrll then
   begin
        xmax:=xmax+oo.sm*(abs(an)/an);
        xmin:=xmin+oo.sm*(abs(an)/an);
   xvec:=xgrmax2-round((-xmin)*xx+(-ymin)*xy);
   yvec:=ygrmax2-ygrmax+round((-ymin)*yy+(-xmin)*yx);
   end
   else
   xz:=xz*cos(an)-yz*sin(an);
   {yz:=xz*sin(an)+yz*cos(an);}
end;

procedure roty(an:real);
begin
{   begin
        ymax:=ymax+an;
        ymin:=ymin+an;
   xvec:=xgrmax2-round((-xmin)*xx+(-ymin)*xy);
   yvec:=ygrmax2-ygrmax+round((-ymin)*yy+(-xmin)*yx);

   end
   else}
   {xz:=xz*cos(an)-yz*sin(an);}
   yz:=xz*sin(an)+yz*cos(an);
end;

function inp:boolean;
var v:char;
    r:word;
    s:string;
label rpt;
begin
rpt:
   mouseoff;
   bar(170,50,470,80);
   setcolor(black);
   rectangle(173,53,467,77);
   outtextxy(280,58,'㭪');
   s:='';r:=0;
   mouseon;
   repeat
   v:=asciikey;
   case v of
     #32..#122:if r<35 then begin outtextxy(r*8+180,68,v);inc(r);s:=s+v; end;
     #8:if r>0 then begin dec(r);setcolor(white);outtextxy(r*8+180,68,'');delete(s,ord(s[0]),1);setcolor(black) end;
     end;
   until (v=#13)or(v=#27);
   if (v=#27)and(dlin=0)then
      begin
      inp:=false;
      exit;
      end;
   if (v=#27) then exit;
   zn:='';
   if test(s,zn,dgt,dlin,per) then exit else goto rpt;
cleardevice;
mouseon;
end;

(*--------------------------------------------------------------------------*)
(*                                PROGRAM                                   *)
(*--------------------------------------------------------------------------*)

begin
dlin:=0;
if paramcount>0 then
   begin
   dosmsg;
   halt(0);
   end;
if (initmouse=2)or(initmouse=3)then mouseexist:=true else mouseexist:=false;
{if registerbgidriver(@bgidriver)<0 then halt;}
gd:=ega;{gm:=vgamed;}
initgraph(gd,gm,'');
scrlloff;
bar(0,0,640,8);
setcolor (black);
outtextxy(0,1,'Invert   Size+   Size-   Refresh   Scroll   Options   Help   Input   Exit');
setcolor(white);
getmem(p,imagesize(0,0,639,8));
getimage(1,1,639,8,p^);
cleardevice;
if not inp then goto stop;
start:
init;
mouseto(xgrmax2,ygrmax2);
repeat
mouseoff;
setactivepage(noact(page));
cleardevice;


endinit;

z:=zmin;
while z<zmax do
      begin
      x:=xmin;
      while x<xmax do
            begin
{            y:=f(x,z);}
            y:=clc(zn,dgt,dlin,x,z);{}
            xout:=xgr(x,y,z);
            yout:=ygr(x,y,z);
            if (xout>0)and(xout<xgrmax)and(yout>0)and(yout<ygrmax) then
               putpixel(xout,yout,white);
            x:=x+oo.dm;
            end;
      z:=z+oo.dn;
      end;
z:=zmin;
while z<zmax do
      begin
      x:=xmin;
      while x<xmax do
            begin
{            y:=f(x,z);}
            y:=clc(zn,dgt,dlin,x,z);{}
            xout:=xgr(x,y,z);
            yout:=ygr(x,y,z);
            if (xout>0)and(xout<xgrmax)and(yout>0)and(yout<ygrmax) then
               putpixel(xout,yout,white);
            x:=x+oo.dn;
            end;
      z:=z+oo.dm;
      end;
page:=noact(page);
setvisualpage(page);
setmousepage(page);
mouseon;
{while keypressed do readkey;}
clrkeybuf;

repeat
    if _keypressed then
        begin
        key:=scankey;
        case key of
           $4B:begin rotx(-oo.an);break end;
           $4D:begin rotx(oo.an);break end;
           $48:if not scrll then begin roty(-oo.an);break end;
           $50:if not scrll then begin roty(oo.an);break end;
           $47:if not scrll then begin rotz(-oo.an);break end;
           $51:if not scrll then begin rotz(oo.an);break end;
           $4A:if abs(sc)>0.1 then begin sc:=sc-0.1*(abs(sc)/sc);break end;
           $4E:if abs(sc)>0.1 then begin sc:=sc+0.1*(abs(sc)/sc);break end;
           $1:goto stop;
           $1C:goto start;
           $37:begin sc:=-sc;break end;
           $4F:if scrll then begin movez(-oo.sm);break end;
           $49:if scrll then begin movez(oo.sm);break end;
           $3B:begin helpinit(mouseexist);clrkeybuf end;
           $3C:begin opt(oo);break end;
           $3D:begin inp;goto start end;{}

         {  $4A:if sc>0 then begin xx:=xx-0.5;break end;
           $4E:begin xx:=xx+0.5;break end;
         }
        end;
        end;
    getmouse(xm,ym,bm);
    if (ym<8)and not menu then begin mouseoff;putimage(0,0,p^,xorput);menu:=true;mouseon;end;
    if (ym>8)and menu then begin mouseoff;putimage(0,0,p^,xorput);menu:=false;mouseon;end;
    if bm=1 then
       begin
       if (xm>xgrmax-40)and(ym>ygrmax2-40)and(ym<ygrmax2+40) then begin rotx(oo.an);break end;
       if (xm<40)and(ym>ygrmax2-40)and(ym<ygrmax2+40) then begin rotx(-oo.an);break end;
       if (ym>ygrmax-40)and(xm>xgrmax2-40)and(xm<xgrmax2+40) then if not scrll then begin roty(oo.an);break end;
       if (ym<40)and(ym>8)and(xm>xgrmax2-40)and(xm<xgrmax2+40) then if not scrll then begin roty(-oo.an);break end;
       if (xm>xgrmax2+40)and(ym>ygrmax2+40) then if not scrll then begin rotz(oo.an);break end;
       if (xm<40)and(ym<40)and(ym>8) then begin if not scrll then rotz(-oo.an);break end;
       if (xm<40)and(ym>ygrmax-40) then if scrll then begin movez(-oo.sm);break end;
       if (xm>xgrmax-40)and(ym<40)and(ym>8) then if scrll then begin movez(oo.sm);break end;
       if menu then
          case xm of
          0..56:begin sc:=-sc;break end;
          64..120:if abs(sc)>0.1 then begin sc:=sc+0.1*(abs(sc)/sc);break end;
          128..184:if abs(sc)>0.1 then begin sc:=sc-0.1*(abs(sc)/sc);break end;
          192..264:goto start;
          272..328:if scrll then scrlloff else scrllon;
          336..408:begin opt(oo);break end;
          416..464:begin helpinit(mouseexist);clrkeybuf end;
          472..528:begin inp;goto start end;{}
          536..584:goto stop;
          end;
       end;
until false;

until key=1;
stop:
scrlloff;
freemem(p,imagesize(0,0,639,8));
closegraph;
end.
{repeat
ex:=true;
case readkey of
     #72:roty(-an);
     #75:rotx(-an);
     #80:roty(an);
     #77:rotx(an);
     #71:rotz(-an);
     #81:rotz(an);
     else ex:=false;
end;
until ex;}