(*--------------------------------------------------------------------------*)
(*    Copyright (c) 1997 Kuleshov Sergey                                    *)
(*    Copyright (c) 1997 ExOS technologies                                  *)
(*--------------------------------------------------------------------------*)

{----------------------}
{------Mouse unit------}
{----------------------}
unit mouse;

interface
function initmouse:word;
procedure mouseon;
procedure mouseoff;
procedure mouseto(x,y:word);
procedure setrangex(max,min:word);
procedure setrangey(max,min:word);
procedure mousespeed(x,y:word);
procedure doublespeed(range:word);
procedure setmousepage(page:word);
function getmousepage:word;
procedure getmouse(var x,y,button:word);
implementation

function initmouse:word;
var k:word;
begin
asm
   MOV AX,00H
   INT 33H
   MOV K,BX
end;
initmouse:=k;
end;

procedure mouseon;assembler;
asm
   MOV AX,01H
   INT 33H
end;

procedure mouseoff;assembler;
asm
   MOV AX,02H
   INT 33H
end;

procedure mouseto(x,y:word);assembler;
asm
   MOV AX,04H
   MOV CX,X
   MOV DX,Y
   INT 33H
end;

procedure setrangex(max,min:word);assembler;
asm
   MOV AX,07H
   MOV CX,MIN
   MOV DX,MAX
   INT 33H
end;

procedure setrangey(max,min:word);assembler;
asm
   MOV AX,08H
   MOV CX,MIN
   MOV DX,MAX
   INT 33H
end;

procedure mousespeed(x,y:word);assembler;
asm
   MOV AX,0FH
   MOV CX,X
   MOV DX,Y
   INT 33H
end;

procedure doublespeed(range:word);assembler;
asm
    MOV AX,13H
    MOV DX,RANGE
    INT 33H
end;

procedure setmousepage(page:word);assembler;
asm
   MOV AX,1DH
   MOV BX,PAGE
   INT 33H
end;

function getmousepage:word;
var k:word;
begin
asm
   MOV AX,1EH
   INT 33H
   MOV K,BX
end;
getmousepage:=k;
end;

procedure getmouse(var x,y,button:word);
var jx,jy,jb:word;
begin;
asm
   MOV AX,03H
   INT 33H
   MOV jx,CX
   MOV jy,DX
   MOV jb,BX
end;
x:=jx;y:=jy;button:=jb;
end;

end.